<template>
  <div>
    <mt-page-title
      :with-border="false"
      :with-padding="false"
      border-style="padding:1.5rem 0"
      link-text="retour à la fiche d'identité"
      :link-to="profilLink({ name: 'pax-id-utilisateur', params: { id: utilisateur.id } })"
    >
      <h1 class="has-text-weight-bold is-size-3">
        Modifier les informations
      </h1>
    </mt-page-title>

    <form @submit.prevent="modifierUtilisateur">
      <div class="columns is-multiline">
        <b-field label="Nom" class="column is-half ">
          <b-input key="user-nom" v-model="utilisateur.nom" placeholder="Nom" class="mt-input" />
        </b-field>

        <b-field label="Prénom" class="column is-half">
          <b-input key="user-prenom" v-model="utilisateur.prenom" placeholder="Prénom" class="mt-input" />
        </b-field>

        <b-field label="E-mail " class="column is-half">
          <b-input
            key="user-email"
            v-model="utilisateur.email"
            disabled="disabled"
            placeholder="E-mail"
            type="email"
            class="mt-input"
          />
        </b-field>

        <b-field label="téléphone" class="column is-half">
          <b-input
            key="user-telephone"
            v-model="utilisateur.telephone"
            disabled="disabled"
            placeholder="téléphone"
            class="mt-input"
          />
        </b-field>

        <b-field label="Catégorie" class="column is-half">
          <b-select v-model="utilisateur.corps" placeholder="Sélectionnez" expanded class="mt-select">
            <option v-for="corp in corps" :key="corp.id" :value="corp">
              {{ corp.libelle }}
            </option>
          </b-select>
        </b-field>

        <b-field label="Poste au Ro " class="column is-half">
          <b-select
            v-model="utilisateur.affectation.posteRo"
            placeholder="Sélectionner un poste"
            expanded
            class="mt-select"
          >
            <option :value="null">
              ---
            </option>
            <option v-for="poste in postesRo" :key="poste.id" :value="poste">
              {{ poste.libelle }}
            </option>
          </b-select>
        </b-field>

        <b-field label="profils" class="column is-full ">
          <div class="columns is-multiline">
            <span
              v-for="(profil, index) in profilsNonEditable"
              :key="`profilsNonEditable.code${index}`"
              class="column is-one-quarter"
            >
              <b-field>
                <b-button
                  class="is-size-8"
                  rounded
                  :type="typeButton({ profil })"
                  :icon-right="iconCheck({ profil })"
                  expanded
                  disabled
                  >{{ profil.description }}
                </b-button>
              </b-field>
            </span>
            <template v-for="(profil, index) in profils">
              <span v-if="!isMe || hasProfil({ profil })" :key="index" class="column is-one-quarter">
                <b-field>
                  <b-button
                    class="is-size-8"
                    rounded
                    :type="typeButton({ profil })"
                    :icon-right="iconCheck({ profil })"
                    expanded
                    :disabled="isMe"
                    @click="addRemoveProfil({ profil })"
                    >{{ profil.description }}
                  </b-button>
                </b-field>
              </span>
            </template>
          </div>
        </b-field>
        <b-field v-if="isSuperEmployeur || isAdminLocal" label="Compte activé ">
          <b-checkbox v-model="utilisateur.enabled" />
        </b-field>
      </div>
      <div class="field is-grouped is-grouped-centered mt-margin-top">
        <div class="control">
          <nuxt-link
            :to="profilLink({ name: 'pax-id-utilisateur', params: { id: utilisateur.id } })"
            class="button is-secondary mt-button is-size-8 "
          >
            Annuler
          </nuxt-link>
        </div>
        <div class="control">
          <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary" native-type="submit">
            Enregistrer
          </b-button>
        </div>
      </div>
    </form>
    <mt-audit :audit="audit"></mt-audit>
    <mt-modal-ok :ouvert.sync="ouvert">
      Le compte a bien été modifié
    </mt-modal-ok>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtModalOk from '~/components/modal/mt-modal-ok';
import MtAudit from '~/components/base/audit/mt-audit';

export default {
  layout: 'container-small',
  components: {
    MtAudit,
    MtPageTitle,
    MtModalOk,
  },
  data() {
    return {
      ouvert: false,
    };
  },
  async asyncData({ $api, params, store }) {
    const [me, utilisateur, postesRo, profils, corps, audit] = await Promise.all([
      $api.utilisateurs.me(),
      $api.utilisateurs.get(params.id),
      $api.postesRo.full(),
      $api.utilisateurs.creationProfils(),
      $api.corps.full(),
      $api.audit.utilisateur(params.id),
    ]);
    const isMe = me.id === utilisateur.id;
    const profilsNonEditable = [];
    for (let i = 0; i < utilisateur.userProfils.length; i += 1) {
      if (!profils.some((profil) => profil.id === utilisateur.userProfils[i].profil.id)) {
        profilsNonEditable.push(utilisateur.userProfils[i].profil);
      }
    }
    if (
      profilsNonEditable.some((p) => p.code === 'super_employeur') &&
      !profilsNonEditable.some((p) => p.code === 'employeur') &&
      utilisateur.userProfils.some((up) => up.profil.code === 'super_employeur')
    ) {
      for (let i = 0; i < profils.length; i += 1) {
        if (profils[i].code === 'employeur') {
          profils.splice(i, 1);
          break;
        }
      }
    }
    const isSuperEmployeur = store.getters['context/isSuperEmployeur'];
    const isAdminLocal = store.getters['context/isAdminLocal'];
    return {
      utilisateur,
      postesRo,
      profils,
      corps,
      audit,
      isSuperEmployeur,
      isAdminLocal,
      profilsNonEditable,
      isMe,
    };
  },
  methods: {
    async modifierUtilisateur() {
      try {
        this.utilisateur = await this.$api.utilisateurs.modifierPartiellement(this.utilisateur);
        this.ouvert = true;
        this.updateAudit();
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-warning',
          duration: 5000,
        });
      }
    },
    async updateAudit() {
      this.audit = await this.$api.audit.utilisateur(this.utilisateur.id);
    },
    typeButton({ profil }) {
      let ret = 'button is-light';
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code) {
          ret = 'button is-primary';
        }
      });
      return ret;
    },
    hasProfil({ profil }) {
      let ret = false;
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code) {
          ret = true;
        }
      });
      return ret;
    },
    iconCheck({ profil }) {
      let ret = '';
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code && mProfil.selected) {
          ret = 'check';
        }
      });
      return ret;
    },
    switchProfil(profil, p1, p2) {
      if (profil.code === p1) {
        let i = 0;
        this.utilisateur.userProfils.forEach((mProfil) => {
          if (mProfil.profil.code === p2) {
            this.utilisateur.userProfils.splice(i, 1);
          }
          i += 1;
        });
      }
    },
    addRemoveProfil({ profil }) {
      let estDansSelect = false;
      let i = 0;
      let index = null;
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code) {
          estDansSelect = true;
          index = i;
        }
        i += 1;
      });
      if (!estDansSelect) {
        this.utilisateur.userProfils.push({ profil, selected: false });
        this.switchProfil(profil, 'employeur', 'super_employeur');
        this.switchProfil(profil, 'super_employeur', 'employeur');
        this.switchProfil(profil, 'employe', 'super_employe');
        this.switchProfil(profil, 'super_employe', 'employe');
      } else if (this.utilisateur.userProfils.length > 1) {
        if (this.utilisateur.userProfils[index].selected) {
          if (index !== 0) {
            this.utilisateur.userProfils[0].selected = true;
          } else {
            this.utilisateur.userProfils[1].selected = true;
          }
        }
        this.utilisateur.userProfils.splice(index, 1);
      } else {
        this.$buefy.notification.open({
          message: "L'utilisateur doit avoir au minimum un profil",
          type: 'is-warning',
        });
      }
      if (this.utilisateur.userProfils.length === 1) {
        this.utilisateur.userProfils[0].selected = true;
      }
    },
  },
};
</script>

<style scoped lang="scss">
.mt-profil-checkbox {
  margin-top: 0.5rem;
  margin-bottom: 1rem;
}
</style>
